/*
	2017.09.21 Takeshi Yoneki
*/
#include <windows.h>
#include <stdio.h>
#include <caml/mlvalues.h>
#include <caml/alloc.h>

/*
int MultiByteToWideChar(
  UINT CodePage,         // コードページ
  DWORD dwFlags,         // 文字の種類を指定するフラグ
  LPCSTR lpMultiByteStr, // マップ元文字列のアドレス
  int cchMultiByte,      // マップ元文字列のバイト数
  LPWSTR lpWideCharStr,  // マップ先ワイド文字列を入れるバッファのアドレス
  int cchWideChar        // バッファのサイズ
);

int WideCharToMultiByte(
  UINT CodePage,         // コードページ
  DWORD dwFlags,         // 処理速度とマッピング方法を決定するフラグ
  LPCWSTR lpWideCharStr, // ワイド文字列のアドレス
  int cchWideChar,       // ワイド文字列の文字数
  LPSTR lpMultiByteStr,  // 新しい文字列を受け取るバッファのアドレス
  int cchMultiByte,      // 新しい文字列を受け取るバッファのサイズ
  LPCSTR lpDefaultChar,  // マップできない文字の既定値のアドレス
  LPBOOL lpUsedDefaultChar   // 既定の文字を使ったときにセットするフラグのアドレス
);
*/

CAMLprim value win_utf8_to_ansi(value vUtf8String) {
	LPCSTR utf8String = String_val(vUtf8String);
	int szw = MultiByteToWideChar(CP_UTF8, 0, utf8String, -1, NULL, 0);
    wchar_t *wideString = malloc(szw * 2);
	szw = MultiByteToWideChar(CP_UTF8, 0, utf8String, -1, wideString, szw);
	int sza = WideCharToMultiByte(CP_ACP, 0, wideString, -1, NULL, 0, NULL, NULL);
    char *ansiString = malloc(sza);
	sza = WideCharToMultiByte(CP_ACP, 0, wideString, -1, ansiString, sza, NULL, NULL);
	value result = caml_copy_string(ansiString);
	free(wideString);
	free(ansiString);
    return result;
}

CAMLprim value win_ansi_to_utf8(value vAnsiString) {
	LPCSTR ansiString = String_val(vAnsiString);
	int szw = MultiByteToWideChar(CP_ACP, 0, ansiString, -1, NULL, 0);
    wchar_t *wideString = malloc(szw * 2);
	szw = MultiByteToWideChar(CP_ACP, 0, ansiString, -1, wideString, szw);
	int sza = WideCharToMultiByte(CP_UTF8, 0, wideString, -1, NULL, 0, NULL, NULL);
    char *utf8String = malloc(sza);
	sza = WideCharToMultiByte(CP_UTF8, 0, wideString, -1, utf8String, sza, NULL, NULL);
	value result = caml_copy_string(utf8String);
	free(wideString);
	free(utf8String);
    return result;
}
